'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var install = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dir, modules) {
    var _this = this;

    var installPeers = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var location;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return config.resolve(dir, ['yarn.lock', 'package.json']);

          case 2:
            location = _context2.sent;
            return _context2.abrupt('return', new _promise2.default(function (resolve, reject) {
              var install = void 0;
              var options = {
                cwd: location ? path.dirname(location) : dir
              };

              if (location && path.basename(location) === 'yarn.lock') {
                install = spawn('yarn', ['add'].concat((0, _toConsumableArray3.default)(modules), ['--dev']), options);
              } else {
                install = spawn('npm', ['install'].concat((0, _toConsumableArray3.default)(modules), ['--save-dev']), options);
              }

              install.stdout.pipe(process.stdout);
              install.stderr.pipe(process.stderr);

              install.on('close', function () {
                var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(code) {
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!(code !== 0)) {
                            _context.next = 2;
                            break;
                          }

                          return _context.abrupt('return', reject(new Error('Failed to install ' + modules.join(', ') + '.')));

                        case 2:
                          if (installPeers) {
                            _context.next = 4;
                            break;
                          }

                          return _context.abrupt('return', resolve());

                        case 4:
                          _context.prev = 4;
                          _context.next = 7;
                          return _promise2.default.all(modules.map(function (m) {
                            return installPeerDependencies(dir, m);
                          }));

                        case 7:
                          _context.next = 12;
                          break;

                        case 9:
                          _context.prev = 9;
                          _context.t0 = _context['catch'](4);
                          return _context.abrupt('return', reject(new Error('Failed to install peerDependencies for ' + modules.join(', ') + '.')));

                        case 12:

                          resolve();

                        case 13:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this, [[4, 9]]);
                }));

                return function (_x4) {
                  return _ref2.apply(this, arguments);
                };
              }());
            }));

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function install(_x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var installPeerDependencies = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(dir, name) {
    var basedir, _ref4, _ref5, resolved, pkg, peers, modules, peer;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            basedir = path.dirname(dir);
            _context3.next = 3;
            return resolve(name, { basedir: basedir });

          case 3:
            _ref4 = _context3.sent;
            _ref5 = (0, _slicedToArray3.default)(_ref4, 1);
            resolved = _ref5[0];
            _context3.next = 8;
            return config.load(resolved, ['package.json']);

          case 8:
            pkg = _context3.sent;
            peers = pkg.peerDependencies || {};
            modules = [];

            for (peer in peers) {
              modules.push(peer + '@' + peers[peer]);
            }

            if (!modules.length) {
              _context3.next = 15;
              break;
            }

            _context3.next = 15;
            return install(dir, modules, false);

          case 15:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function installPeerDependencies(_x5, _x6) {
    return _ref3.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var spawn = require('cross-spawn');
var config = require('./config');
var path = require('path');
var promisify = require('./promisify');
var resolve = promisify(require('resolve'));

module.exports = install;